#!/usr/bin/python2.4
#
# Copyright 2005 Lars Wirzenius (liw@iki.fi)
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA


"""Enemies of Carlotta, a mailing list manager."""


import logging
import optparse
import os
import sys


import eoc


def main():
    eoc.log.setup([])
    logging.debug("EoC %s starting up." % eoc.defaults.VERSION)

    try:
        plugin_manager = eoc.plugins.PluginManager()
        plugin_manager.load()
        
        eoc.hooks.setup_option_parser()
        (options, args) = eoc.options.parse(sys.argv[1:])
        logging.debug("Options:\n%s" % options)
        logging.debug("Arguments:\n%s" % args)
        
        mlm = eoc.mlm.MailingListManager(options.dotdir)
        
        eoc.hooks.handle_options(mlm, options, args)

    except eoc.exceptions.EocException, e:
        logging.error(str(e) + "\n")
        sys.exit(os.EX_TEMPFAIL)

if __name__ == "__main__":
    main()
