#!/bin/sh


setUp()
{
    rm -rf dot-dir
}


tearDown()
{
    rm -rf dot-dir
}


runOnly()
{
    temp=$(mktemp)
    python2.4 enemies-of-carlotta.py "$@" > "$temp"
}


run()
{
    temp=$(mktemp)
    python2.4 enemies-of-carlotta.py "$@" > "$temp"
    ret=$?
    if [ $ret != 0 ]
    then
        cat "$temp"
        rm -f "$temp"
        exit 1
    fi
    rm -f "$temp"
}


failUnless()
{
    if ! "$@"
    then
        echo Test "'$@'" failed 1>&1
        exit 1
    fi
}


failIf()
{
    if "$@"
    then
        echo Test "'$@'" "failed (returned true)" 1>&1
        exit 1
    fi
}


# Test creation of list.
setUp
failUnless test ! -e dot-dir/staff@example.com
run --name=staff@example.com --create
failUnless test -e dot-dir/staff@example.com
tearDown


# Test adding and removing a subscriber from command line.
setUp
run --name=staff@example.com --create
run --name=staff@example.com --subscribe boss@example.com
failUnless test -s dot-dir/staff@example.com/subs
run --name=staff@example.com --unsubscribe boss@example.com
failUnless test ! -s dot-dir/staff@example.com/subs
tearDown


# Test incoming message for incorrect address.
setUp
run --name=staff@example.com --create
SENDER=boss@example.com RECIPIENT=wrong@example.com failIf runOnly --incoming << EOF
From: boss@example.com
To: staff@example.com
Subject: Bonuses

Everyone will get a bonus this year.
EOF
tearDown


# Report success
echo "All tests OK."
